<?php
/**
 * Plugin Name: Easy Amazon Wishlist
 * Description: This plugin will display an Amazon Wishlist or Idea List with your list item links in your sidebar having a customizable look and feel.  Available in english, deutsch, español, français, italiano, 日本人, 中国的.  Want to thank me or get my attention?  Buy me a coffee at https://Ko-fi.com/webmasterninjas. For bugs or features contact: hokage@webmasterninjas.com
 * Version: 2.2.1
 * Author: Stan Quinn
 * Author URI: https://www.webmasterninjas.com
 * License: GPL
 */

//TODO remove items without names/links
//TODO check if wishlist items bought still appear
//TODO create wordpress cron job to update wishlist?
//TODO sitewide, per category, per page, per blog
//TODO List Feature poll

//Test lists urls

// zero list
// https://www.amazon.com/hz/wishlist/ls/2B3357DI8QKEG?type=wishlist&ref=cm_wl_list_create
// single list
//https://www.amazon.com/hz/wishlist/ls/1LA21KDLHYA5J?&sort=default
// double list
//https://www.amazon.com/hz/wishlist/ls/2T9IQYKMNIX8L?&sort=default
// list with single idea
//https://www.amazon.com/hz/wishlist/ls/2Z5S5SVSGZUW6?filter=DEFAULT&viewType=list&lek=d59fb73d-e2e8-4ccd-89d5-73d5b6cb3cee&sort=default&type=wishlist
// long wishlist
//https://www.amazon.com/hz/wishlist/ls/SRY9ACDQGSRT?filter=DEFAULT&viewType=list&lek=36998bb1-7a47-40ab-b755-8ab235cdcb0f&sort=default&type=wishlist
// long idea list
// https://www.amazon.com/ideas/amzn1.account.AHWEHXLSUKTGPJIDYXYVN3GRIVEQ/3LXYXW2B49BVA?type=explore&ref=idea_cp_vl_ov_d

//Foreign lists

session_start();
// Create a new CSRF token.
if (!isset($_SESSION['csrf_token'])) {
    $_SESSION['csrf_token'] = base64_encode(openssl_random_pseudo_bytes(32));
}

error_reporting(0); //turns off error reporting
//ini_set("log_errors", 1);
//ini_set("error_log", plugin_dir_path(__FILE__) . "php-error.log");

add_action('init', 'easy_amazon_wishlist');

function easy_amazon_wishlist()
{
    //$dir = plugin_dir_path( __FILE__ );
    $plugin_dir = basename(dirname(__FILE__));
    load_plugin_textdomain('EasyAmazonWishlist', null, $plugin_dir);

    $wishlist_temp_file = plugin_dir_path(__FILE__) . 'wishlist.json.cache.temp'; //temp file is for wishlist preview
    $cache_file = plugin_dir_path(__FILE__) . 'wishlist.json.cache';


    if (isset($_POST['action']) && ($_POST['action'] == 'update')) { //update and save

        $listType = $_POST['easy-amazon-wishlist-list-type'];
        //$listID = $_POST['easy-amazon-wishlist-listID'];
        $listUrl = $_POST['easy-amazon-wishlist-list-url'];
        $ideaListUrl = $_POST['easy-amazon-wishlist-idea-list-url'];
        $website = $_POST['easy-amazon-wishlist-websites'];
        $title = $_POST['easy-amazon-wishlist-h2-title'];
        $show_text_link = $_POST['easy-amazon-wishlist-show-text-link'];
        $show_image = $_POST['easy-amazon-wishlist-show-image'];
        $show_price = $_POST['easy-amazon-wishlist-show-price'];
        $show_button = $_POST['easy-amazon-wishlist-show-button'];
        $button_text = $_POST['easy-amazon-wishlist-button-text'];
        $text_link_char_limit = $_POST['easy-amazon-wishlist-text-link-char-limit'];
        $background_color = $_POST['easy-amazon-wishlist-background-color'];
        $link_color = $_POST['easy-amazon-wishlist-text-link-color'];
        $button_color = $_POST['easy-amazon-wishlist-button-color'];
        $button_text_color = $_POST['easy-amazon-wishlist-button-text-color'];
        $affiliate_option = $_POST['easy-amazon-wishlist-affiliate-option'];
        $affiliate_id = $_POST['easy-amazon-wishlist-affiliate-id'];
        $pagination_option = $_POST['easy-amazon-wishlist-pagination-option'];
        $pagination_limit = $_POST['easy-amazon-wishlist-pagination-limit'];

        //it's using whatever is in the database....the last previewed/saved
        $listJson = $_POST['easy-amazon-wishlist-json']; //posted with form...deserialize?  remove slashes from double quotes?
        if ($listJson) {
            $listArray = json_decode($listJson);
        } else {
            $listArray = [];
        }

        /*if (file_exists($wishlist_temp_file) && !copy($wishlist_temp_file, $cache_file)) {
            error_log("failed to copy $wishlist_temp_file");
        }else{
            if(!file_exists($cache_file)) {
                file_put_contents($cache_file, "[]");
                $wishlistObject = [];
            }else{
                $wishlistObject = json_decode(file_get_contents($wishlist_temp_file));
            }
        }*/

        return easyAmazonWishlistDisplayPreviewList($title, $listType, $listUrl, $ideaListUrl, $website, $listArray, $show_text_link, $show_image, $show_price, $show_button, $button_text, $text_link_char_limit, $affiliate_option, $affiliate_id, $pagination_option, $pagination_limit, $background_color, $link_color, $button_color, $button_text_color);
    } else {
        $title = get_option('easy-amazon-wishlist-h2-title');
        $listType = get_option('easy-amazon-wishlist-list-type');
        //$listId = get_option('easy-amazon-wishlist-listID');
        $listUrl = get_option('easy-amazon-wishlist-list-url');
        $ideaListUrl = get_option('easy-amazon-wishlist-idea-list-url');
        $website = get_option('easy-amazon-wishlist-websites');
        $show_text_link = get_option('easy-amazon-wishlist-show-text-link');
        $show_image = get_option('easy-amazon-wishlist-show-image');
        $show_price = get_option('easy-amazon-wishlist-show-price');
        $show_button = get_option('easy-amazon-wishlist-show-button');
        $button_text = get_option('easy-amazon-wishlist-button-text');
        $text_link_char_limit = get_option('easy-amazon-wishlist-text-link-char-limit');
        $affiliate_option = get_option('easy-amazon-wishlist-affiliate-option');
        $affiliate_id = get_option('easy-amazon-wishlist-affiliate-id');
        $pagination_option = get_option('easy-amazon-wishlist-pagination-option');
        $pagination_limit = get_option('easy-amazon-wishlist-pagination-limit');
        $background_color = get_option('easy-amazon-wishlist-background-color');
        $link_color = get_option('easy-amazon-wishlist-text-link-color');
        $button_color = get_option('easy-amazon-wishlist-button-color');
        $button_text_color = get_option('easy-amazon-wishlist-button-text-color');
        $json = get_option('easy-amazon-wishlist-json');
        if ($json) {
            $listArray = json_decode($json);
        } else {
            $listArray = [];
        }
        //TODO pull from flat file
        //if it's not an update, just serve up the html in cache...easy peasy and lightning quick
        /*$wishlistHtml = plugin_dir_path( __FILE__ )  . 'wishlist.html.cache';
        //serve up wishlist html include
        if (file_exists($wishlistHtml)) {
            $wishlist = file_get_contents($wishlistHtml);
            return $wishlist;
        }else{
            return "";
        }*/
        return easyAmazonWishlistDisplayPreviewList($title, $listType, $listUrl, $ideaListUrl, $website, $listArray, $show_text_link, $show_image, $show_price, $show_button, $button_text, $text_link_char_limit, $affiliate_option, $affiliate_id, $pagination_option, $pagination_limit, $background_color, $link_color, $button_color, $button_text_color);
    }
}

if (is_admin() === true) {

    /* Call the html code */
    add_action('admin_menu', 'easy_amazon_wishlist_admin_menu');

    function easy_amazon_wishlist_admin_menu()
    {
        global $pw_settings_page;
        $pw_settings_page = add_options_page(__('Easy Amazon Wishlist', 'EasyAmazonWishlist'), __('Easy Amazon Wishlist', 'EasyAmazonWishlist'), 'administrator', 'easy-amazon-wishlist', 'easy_amazon_wishlist_admin_page');
    }

    add_action('wp_ajax_eaw_preview_wishlist_action', 'eaw_preview_wishlist_callback');
    add_action('wp_ajax_eaw_preview_idea_list_action', 'eaw_preview_idea_list_callback');

    function eaw_preview_wishlist_callback()
    {
        //TODO cache wishlist a temporary wishlist reading from amazon
        //check_ajax_referer( 'my-special-string', 'security' );
        ob_start();
        require_once(plugin_dir_path(__FILE__) . 'readAmazonWishlist.php');
        $wishlistObjects = ob_get_clean();
        //$success = file_put_contents($wishlistObjects, plugin_dir_path( __FILE__ )  . 'wishlist.json.cache.temp', FILE_TEXT);
        if ($wishlistObjects) {
            /* TODO add back in caching
            $file = plugin_dir_path(__FILE__) . 'wishlist.json.cache.temp'; //TODO get cache working
            $open = fopen($file, "a");
            $write = fputs($open, $wishlistObjects);
            fclose($write);*/
            error_log($wishlistObjects);
            echo $wishlistObjects;
            /*if (!$open) {
                error_log('Failure to write wishlist to file: ' . plugin_dir_path(__FILE__) . 'wishlist.json.cache.temp');
            }*/
        }
        die(); //keeps a 0 from appearing at the end of the json output
    }

    function eaw_preview_idea_list_callback()
    {

        ob_start();
        require_once(plugin_dir_path(__FILE__) . 'readAmazonIdeaList.php');
        $listObjects = ob_get_clean();
        if ($listObjects) {
            $file = plugin_dir_path(__FILE__) . 'wishlist.json.cache.temp';
            $open = fopen($file, "a");
            $write = fputs($open, $listObjects);
            fclose($write);
            echo $listObjects;
            if (!$open) {
                error_log('Failure to write idea list to file');
            }
        }

        //$success = file_put_contents($listObjects, plugin_dir_path( __FILE__ )  . 'wishlist.json.cache.temp', FILE_TEXT);

        die(); // this is required to return a proper result
        //}
    }

}

function easy_amazon_wishlist_admin_page()
{


    if (is_admin() === true) {

        //TODO move to pw_load_scripts when it's working
        add_action('admin_footer', 'easy_amazon_wishlist_action_javascript');

        function easy_amazon_wishlist_action_javascript()
        {

            $wishlistArray = null;
            $cache_file = __DIR__ . 'easy-amazon-wishlist.json.cache.temp';
            if (file_exists($cache_file)) {
                $wishlist_json = file_get_contents($cache_file);
                $wishlists = json_decode($wishlist_json);
                for ($i = 0; $i < count($wishlists); $i++) {
                    $wishlistArray[] = $wishlists[$i];
                }
            }
            //TODO remove
//            $wishlistArray = json_decode(stripslashes(get_option('easy-amazon-wishlist-json')));
            ?>
            <script type='text/javascript' src='<?= plugin_dir_url(__FILE__) ?>vanilla-picker.min.js?ver=2.10'></script>
            <script type="text/javascript">

                window.csrf = {csrf_token: '<?php echo $_SESSION['csrf_token']; ?>'};

                jQuery(document).ready(function ($) {

                    $.ajaxSetup({
                        data: window.csrf
                    });

                    //START MAIN APP OBJECT
                    var easyAmazonWishlistWidget = (function ($, Picker) { //Objects needed when they are ready

                            //APPLICATION VARIABLES
                            var wishlistArray = <?php echo json_encode($wishlistArray, JSON_HEX_QUOT); ?>;
                            var MONTH_NAMES = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");
                            var DAY_NAMES = new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
                            var easyAmazonWishlists = {};

                            //Start setupBindings
                            function setupBindings() {

                                $(window).bind('beforeunload', function (e) {
                                    e.stopPropagation();
                                    if ($('.save-list').hasClass('list-modified')) {
                                        e.returnValue = "You have unsaved changes.";
                                        return e.returnValue;
                                    }
                                });
                                //do UI bindings
                                //BUTTONS/////////////////////////////////////////////

                                $(window).bind('beforeunload', function (e) {
                                    e.stopPropagation();
                                    if ($('#easy-amazon-wishlist-update').hasClass('easy-amazon-wishlist-modified')) {
                                        e.returnValue = '<?= __('You have unsaved changes. Click "update" to save your changes', 'EasyAmazonWishlist'); ?>';
                                        return e.returnValue;
                                    }
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-h2-title', function (e) {
                                    $('#wishlist-preview h2').text($('#easy-amazon-wishlist-h2-title').val());
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                //Select List Type

                                $(document).on('change', '#easy-amazon-wishlist-list-type', function (e) {
                                    //Show list input and hide the others
                                    var listType = $('#easy-amazon-wishlist-list-type').val();
                                    if (listType === "amazon-wishlist") {
                                        $('#easy-amazon-idea-list-div').hide();
                                        $('#easy-amazon-wishlist-div').slideDown("slow");
                                    }
                                    if (listType === "amazon-idea-list") {
                                        $('#easy-amazon-wishlist-div').hide();
                                        $('#easy-amazon-idea-list-div').slideDown("slow");
                                    }

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-background-color', function (e) {
                                    var color = $(this).val();
                                    $('#easy-amazon-wishlist-list').each(function (i) {
                                        $(this).css('background-color', color);
                                    });

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                var listBackgroundColorPickerDiv = document.querySelector('#easy-amazon-wishlist-background-color-picker');
                                var easyAmazonWishlistBackgroundColor = $('#easy-amazon-wishlist-background-color');

                                var backgroundColorPicker = new Picker({
                                    parent: listBackgroundColorPickerDiv,
                                    color: easyAmazonWishlistBackgroundColor.val(),
                                    onDone: function (color) {
                                        listBackgroundColorPickerDiv.style.background = color.rgbaString;
                                        easyAmazonWishlistBackgroundColor.val(color.rgbaString);
                                        easyAmazonWishlistBackgroundColor.trigger('keyup');
                                    }
                                });

                                var listLinkColorPickerDiv = document.querySelector('#easy-amazon-wishlist-text-link-color-picker');
                                var easyAmazonWishlistLinkColor = $('#easy-amazon-wishlist-text-link-color');

                                var linkColorPicker = new Picker({
                                    parent: listLinkColorPickerDiv,
                                    color: easyAmazonWishlistLinkColor.val(),
                                    onDone: function (color) {
                                        listLinkColorPickerDiv.style.background = color.rgbaString;
                                        easyAmazonWishlistLinkColor.val(color.rgbaString);
                                        easyAmazonWishlistLinkColor.trigger('keyup');
                                    }
                                });

                                var listButtonColorPickerDiv = document.querySelector('#easy-amazon-wishlist-button-color-picker');
                                var easyAmazonWishlistButtonColor = $('#easy-amazon-wishlist-button-color');

                                var buttonColorPicker = new Picker({
                                    parent: listButtonColorPickerDiv,
                                    color: easyAmazonWishlistButtonColor.val(),
                                    onDone: function (color) {
                                        listButtonColorPickerDiv.style.background = color.rgbaString;
                                        easyAmazonWishlistButtonColor.val(color.rgbaString);
                                        easyAmazonWishlistButtonColor.trigger('keyup');
                                    }
                                });

                                var listButtonTextColorPickerDiv = document.querySelector('#easy-amazon-wishlist-button-text-color-picker');
                                var easyAmazonWishlistButtonTextColor = $('#easy-amazon-wishlist-button-text-color');

                                var buttonTextColorPicker = new Picker({
                                    parent: listButtonTextColorPickerDiv,
                                    color: easyAmazonWishlistButtonTextColor.val(),
                                    onDone: function (color) {
                                        listButtonTextColorPickerDiv.style.background = color.rgbaString;
                                        easyAmazonWishlistButtonTextColor.val(color.rgbaString);
                                        easyAmazonWishlistButtonTextColor.trigger('keyup');
                                    }
                                });

                                $(document).on('change', '#easy-amazon-wishlist-show-text-link', function (e) {
                                    /* easy-amazon-wishlist-title */
                                    if (!$('#easy-amazon-wishlist-show-text-link').prop('checked')) {
                                        $('.easy-amazon-wishlist-title').hide();

                                    } else {
                                        $('.easy-amazon-wishlist-title').show(function (e) {
                                            $('#easy-amazon-wishlist-text-link-char-limit').trigger('keyup');
                                        });

                                    }
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-text-link-char-limit', function (e) {

                                    var char_limit = parseInt($('#easy-amazon-wishlist-text-link-char-limit').val());

                                    if (char_limit) {

                                        $('.easy-amazon-wishlist-title a').each(function (i) {

                                            var original_string = $(this).attr('title');
                                            var substr = original_string;

                                            if (original_string.length > char_limit) {
                                                substr = original_string.substring(0, char_limit);
                                            }

                                            if (original_string.length > substr.length) {
                                                substr = substr + '...';
                                            }
                                            $(this).text(substr);
                                        });
                                        $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                    }
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-button-text', function (e) {
                                    $('.easy-amazon-wishlist-button button').each(function (i) {
                                        $(this).text($('#easy-amazon-wishlist-button-text').val());
                                    });
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');

                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-background-color', function (e) {
                                    /*$('.easy-amazon-wishlist-button button').each(function(i) {
                                        $(this).text($('#easy-amazon-wishlist-button-text').val());
                                    });*/
                                    $('#wishlist-preview').css('background-color', $(this).val());

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-text-link-color', function (e) {
                                    var color = $(this).val();
                                    $('#wishlist-preview a').each(function (i) {
                                        $(this).css('color', color);
                                    });

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-button-color', function (e) {
                                    var color = $(this).val();
                                    $('#wishlist-preview button').each(function (i) {
                                        $(this).css('background-color', color);
                                    });

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keyup', '#easy-amazon-wishlist-button-text-color', function (e) {
                                    var color = $(this).val();
                                    $('#wishlist-preview button').each(function (i) {
                                        $(this).css('color', color);
                                    });

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });


                                $(document).on('change', '#easy-amazon-wishlist-affiliate-option', function (e) {
                                    //check if true....show affiliate ID input

                                    if (!$('#easy-amazon-wishlist-affiliate-option').prop('checked')) {
                                        $('.affiliate-row').hide();

                                        $('#wishlist-preview a').each(function (i) {
                                            var link = $(this).prop('href');
                                            var linkArray = link.split('&tag=');

                                            linkArray[linkArray.length - 1] = 'wwwwebmastern-20';

                                            $(this).prop('href', linkArray.join());
                                        });

                                    } else {
                                        $('.affiliate-row').show();
                                    }
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');

                                });

                                $(document).on('change', '#easy-amazon-wishlist-pagination-option', function (e) {
                                    //check if true....show pagination option
                                    var paginationOption = $('#easy-amazon-wishlist-pagination-option').is(':checked');
                                    var paginationLimit = parseInt($(this).val().trim());

                                    if (paginationOption && paginationLimit) {

                                        var numItems = $('#easy-amazon-wishlist-list .single-list-item').length;
                                        var pagination = new EasyAmazonWishlistPagination(paginationLimit, numItems);
                                        pagination.updatePagination(paginationLimit);
                                        jQuery('.pagination-input-row').show();
                                    }else{
                                        jQuery('#easy-amazon-wishlist-list .single-list-item').show();
                                        jQuery('.pagination-input-row').hide();
                                        jQuery('#easy-amazon-wishlist-list .pagination-row').html("");
                                    }

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');

                                });

                                $(document).on('keyup keypress blur change', '#easy-amazon-wishlist-pagination-limit', function (e) {

                                    var paginationOption = $('#easy-amazon-wishlist-pagination-option').is(':checked');
                                    var paginationLimit = parseInt($(this).val().trim());

                                    if (paginationOption && paginationLimit) {

                                        var numItems = $('#easy-amazon-wishlist-list .single-list-item').length;
                                        var pagination = new EasyAmazonWishlistPagination(paginationLimit, numItems);
                                        pagination.updatePagination(paginationLimit);
                                    }

                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');

                                });

                                $(document).on('change', '#easy-amazon-wishlist-show-image', function (e) {
                                    /* easy-amazon-wishlist-title */
                                    if (!$('#easy-amazon-wishlist-show-image').prop('checked')) {
                                        $('.easy-amazon-wishlist-image').hide();

                                    } else {
                                        $('.easy-amazon-wishlist-image').show();
                                    }
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('change', '#easy-amazon-wishlist-show-price', function (e) {
                                    if (!$('#easy-amazon-wishlist-show-price').prop('checked')) {
                                        $('.easy-amazon-wishlist-price').hide();

                                    } else {
                                        $('.easy-amazon-wishlist-price').show();
                                    }
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('change', '#easy-amazon-wishlist-show-button', function (e) {
                                    /* easy-amazon-wishlist-title */
                                    if (!$('#easy-amazon-wishlist-show-button').prop('checked')) {
                                        $('.easy-amazon-wishlist-button').hide();

                                    } else {
                                        $('.easy-amazon-wishlist-button').show();
                                    }
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('click', '#easy-amazon-wishlist-update', function (e) {
                                    $('#easy-amazon-wishlist-update').removeClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('click', "#easy-amazon-wishlist-preview-button", function (e) {
                                    e.preventDefault();
                                    e.stopPropagation();
                                    var thisButton = $(this);
                                    previewWishlist(thisButton, $('#easy-amazon-wishlist-list-url').val(), $('#easy-amazon-wishlist-websites').val());
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('click', "#easy-amazon-wishlist-idea-list-preview-button", function (e) {
                                    e.preventDefault();
                                    e.stopPropagation();
                                    var thisButton = $(this);
                                    previewIdeaList(thisButton, $('#easy-amazon-wishlist-idea-list-url').val(), $('#easy-amazon-wishlist-websites').val());
                                    $('#easy-amazon-wishlist-update').addClass('easy-amazon-wishlist-modified');
                                });

                                $(document).on('keydown', "#easy-amazon-wishlist-list-url", function (e) {
                                    if (e.which == 13) {
                                        e.preventDefault();
                                        e.stopPropagation();
                                        $('#easy-amazon-wishlist-preview-button').click();
                                    }
                                });

                                $(document).on('keydown', "#easy-amazon-wishlist-idea-list-url", function (e) {
                                    if (e.which == 13) {
                                        e.preventDefault();
                                        e.stopPropagation();
                                        $('#easy-amazon-wishlist-idea-list-preview-button').click();
                                    }
                                });

                                //Initialize Wishlist from settings

                                $('#easy-amazon-wishlist-show-text-link').trigger('change');
                                $('#easy-amazon-wishlist-text-link-char-limit').trigger('keyup');
                                $('#easy-amazon-wishlist-show-image').trigger('change');
                                $('#easy-amazon-wishlist-show-price').trigger('change');
                                $('#easy-amazon-wishlist-show-button').trigger('change');
                                $('#easy-amazon-wishlist-button-text').trigger('change');
                                $('#easy-amazon-wishlist-affiliate-id').trigger('change');
                                $('#easy-amazon-wishlist-pagination-option').trigger('change');
                                $('#easy-amazon-wishlist-pagination-limit').trigger('change');
                                $('#easy-amazon-wishlist-background-color').trigger('keyup');
                                $('#easy-amazon-wishlist-text-link-color').trigger('keyup');
                                $('#easy-amazon-wishlist-button-color').trigger('keyup');
                                $('#easy-amazon-wishlist-button-text-color').trigger('keyup');
                                $('#easy-amazon-wishlist-update').removeClass('easy-amazon-wishlist-modified');

                            }//END setupBindings()

                            //APP INITIALIZATION/////////////////////////////////////////////////////////////////////
                            easyAmazonWishlists.init = function () {
                                setupBindings();

                            }//END OF APP INTIALIZATION//////////////////////////////////////////////////////////////

                            //START OF INTERNAL PRIVATE FUNCTIONS////////////////////////////////////////////////////

                            previewWishlist = function (button, wishlistUrl, country) {
                                var text = button.text();
                                $.ajax({
                                    url: "<?php echo admin_url('admin-ajax.php'); ?>",
                                    type: 'POST',
                                    data: {
                                        action: 'eaw_preview_wishlist_action',
                                        csrf_token: '<?php echo $_SESSION['csrf_token']; ?>',
                                        wishlistUrl: wishlistUrl,
                                        country: country
                                    },
                                    beforeSend: function () {
                                        $('#wishlist-preview').html('<div class="loader"><?= esc_attr_e('Loading', 'EasyAmazonWishlist'); ?><span class="easyAmazonWishlistLoader__dot">.</span><span class="easyAmazonWishlistLoader__dot">.</span><span class="easyAmazonWishlistLoader__dot">.</span></div>');
                                        button.text('<?= esc_attr_e('Loading', 'EasyAmazonWishlist'); ?>...');
                                    },
                                    success: function (myresult) {

                                        //returning curl pointer which is not json
                                        if (myresult) {
                                            var wishlistArray = $.parseJSON(myresult);

                                            easyAmazonWishlistDisplayPreviewWishlist(wishlistArray);
                                            $('#easy-amazon-wishlist-json').val(myresult);
                                        } else {
                                            //TODO error in myresult
                                            $('#wishlist-preview').text("<?= esc_attr_e("Failed to load List Result", 'EasyAmazonWishlist'); ?>.").html();
                                        }
                                        button.text(text);
                                    },
                                    error: function (myresult) {
                                        $('#wishlist-preview').text("<?= esc_attr_e("Failed to load List Error", 'EasyAmazonWishlist'); ?>.").html();
                                        button.text(text);
                                    }
                                });
                            }

                            previewIdeaList = function (button, ideaListUrl, country) {

                                var text = button.text();

                                //might have to pass in or read affiliate ID
                                $.ajax({
                                    url: "<?php echo admin_url('admin-ajax.php'); ?>",
                                    type: 'POST',
//                                contentType: "application/json; charset=utf-8",
//                                dataType: "json",
                                    data: {
                                        action: 'eaw_preview_idea_list_action',
                                        csrf_token: '<?php echo $_SESSION['csrf_token']; ?>',
                                        ideaListUrl: encodeURIComponent(ideaListUrl),
                                        country: country
                                    },
                                    beforeSend: function () {
                                        $('#wishlist-preview').html('<?= esc_attr_e('Loading', 'EasyAmazonWishlist'); ?>...');
                                        button.text('<?= esc_attr_e('Loading', 'EasyAmazonWishlist'); ?>...');
                                    },
                                    success: function (myresult) {
                                        if (!myresult) {
                                            $('#wishlist-preview').html('Empty Wishlist Returned');
                                        } else {
                                            var wishlistArray = $.parseJSON(myresult);
                                            easyAmazonWishlistDisplayPreviewIdeaList(wishlistArray);
                                            $('#easy-amazon-wishlist-json').val(myresult); //Saved in form as json to store in database
                                        }
                                        button.text(text);
                                    },
                                    error: function (myresult) {
                                        $('#wishlist-preview').text("<?= esc_attr_e("Failed to load Idea List.  Please verify that this is a valid Idea List Url", 'EasyAmazonWishlist'); ?>.").html();
                                        button.text(text);
                                    }
                                })
                            };

                            var easyAmazonWishlistDisplayPreviewWishlist = function (wishlistArray) {
                                var amazonStore = $('#easy-amazon-wishlist-websites').val();
                                var wishlistUrl = $('#easy-amazon-wishlist-list-url').val();
                                var buttonText = $('#easy-amazon-wishlist-button-text').val();
                                var backgroundColor = $('#easy-amazon-wishlist-background-color').val();
                                var linkColor = $('#easy-amazon-wishlist-text-link-color').val();
                                var buttonColor = $('#easy-amazon-wishlist-button-color').val();
                                var buttonTextColor = $('#easy-amazon-wishlist-button-text-color').val();
                                var title = $('#easy-amazon-wishlist-h2-title').val();
                                var affiliateOption = $('#easy-amazon-wishlist-affiliate-option').is(":checked")
                                var affiliateId = $('#easy-amazon-wishlist-affiliate-id').val();
                                var paginationOption = $('#easy-amazon-wishlist-pagination-option').is(":checked")
                                var paginationLimit = $('#easy-amazon-wishlist-pagination-limit').val();
                                var regex = /(https:\/\/|http:\/\/)?(www\.)?amazon\.co(.*)\/wishlist\/(.*)\/([a-zA-Z0-9]+)(\/.*|\?.*)?/gm;
                                var m;
                                var wishlistId;

                                if ((m = regex.exec(wishlistUrl)) !== null) {
                                    wishlistId = m[4];
                                }
//TODO may want to just use the url they give me
                                var wishlist = '<div id="easy-amazon-wishlist-list" style="' + backgroundColor + '"><h2 style="text-align:center;"><a href="https://www.amazon.' + amazonStore + '/gp/registry/wishlist/' + wishlistId + '/?ref=wl_share&sort=default&tag=' + affiliateId + '" target="_blank">' + title + '</a></h2>';//'';

                                if (typeof wishlistArray !== 'undefined' && wishlistArray !== null) {

                                    $('#easy-amazon-wishlist-json').val(JSON.stringify(wishlistArray));

                                    for (var i = 0; i < wishlistArray.length; i++) {

                                        var display = "";
                                        if (paginationOption && (i >= paginationLimit)) {
                                            display = "display:none;";
                                        } else {
                                            display = "";
                                        }

                                        var link = "";
                                        var linkArray = [];

                                        /*if(affiliateOption){
                                            link = wishlistArray[i].link
                                            linkArray = link.split('&tag=');
                                            linkArray[linkArray.length-1] = '&tag='+affiliateId;
                                            link =  linkArray.join("");
                                        }else{ */
                                        //TODO use regex to strip tag param so this always works
                                        link = wishlistArray[i]['link'];
                                        linkArray = link.split('&tag=');
                                        link = linkArray[0] + '&tag=' + affiliateId;
                                        /* } */

                                        wishlist = wishlist + '<div style="' + display + '" class="single-list-item"><div class="easy-amazon-wishlist-title"><a style="' + linkColor + '" title="' + wishlistArray[i]["name"] + '" href="' + link + '" target="_blank">' + wishlistArray[i]["name"] + '</a></div><div><div class="easy-amazon-wishlist-image-div"><a title="' + wishlistArray[i]["name"] + '" class="easy-amazon-wishlist-image" href="' + link + '" target="_blank"><img class="img-responsive" alt="' + wishlistArray[i]["name"] + '" src="' + wishlistArray[i]["img"] + '" /></a></div><div class="easy-amazon-wishlist-price-button"><div class="easy-amazon-wishlist-price">' + wishlistArray[i]["price"] + '</div><div class="easy-amazon-wishlist-button"><a style="' + linkColor + '" target="_blank" class="easy-amazon-wishlist-button" href="' + link + '" target="_blank"><button style="background-color:' + buttonColor + ';color:' + buttonTextColor + '" class="button">' + buttonText + '</button></a></div></div></div></div>';
                                    }
                                } else {
                                    wishlist = wishlist + '[EMPTY WISHLIST]';
                                    wishlistArray = [];
                                }

                                wishlist = wishlist + '<div class="pagination-row">';

                                if (paginationOption && Array.isArray(wishlistArray)) {
                                    var numItems = wishlistArray.length;
                                    var easyAmazonWishlistPagination = new EasyAmazonWishlistPagination(parseInt(paginationLimit), numItems);

                                    wishlist = wishlist + easyAmazonWishlistPagination.toString();
                                }
                                wishlist = wishlist + '</div></div>';

//TODO store string in form....this is what should be cached...update string/store when saved
                                $('#wishlist-preview').html(wishlist).slideDown('slow', function (e) {
                                    //trigger all of the current display options
                                    $('#easy-amazon-wishlist-show-text-link').trigger('change');
                                    $('#easy-amazon-wishlist-text-link-char-limit').trigger('keyup');
                                    $('#easy-amazon-wishlist-show-image').trigger('change');
                                    $('#easy-amazon-wishlist-show-price').trigger('change');
                                    $('#easy-amazon-wishlist-show-button').trigger('change');
                                    $('#easy-amazon-wishlist-button-text').trigger('keyup');
                                    $('#easy-amazon-wishlist-affiliate-id').trigger('keyup');
//*                                    $('#easy-amazon-wishlist-pagination-option').trigger('keyup');*/
//*                                   $('#easy-amazon-wishlist-pagination-limit').trigger('keyup');*/
                                    $('#easy-amazon-wishlist-background-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-text-link-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-button-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-button-text-color').trigger('keyup');
                                    if (paginationOption) {
                                        easyAmazonWishlistPagination.createButtonEvents();
                                    }
                                });

                            }

                            var easyAmazonWishlistDisplayPreviewIdeaList = function (wishlistArray) {

                                var listType = $('#easy-amazon-wishlist-list-type').val();
                                var ideaListUrl = $('#easy-amazon-wishlist-idea-list-url').val();
                                var buttonText = $('#easy-amazon-wishlist-button-text').val();
                                var backgroundColor = $('#easy-amazon-wishlist-background-color').val();
                                var linkColor = $('#easy-amazon-wishlist-text-link-color').val();
                                var buttonColor = $('#easy-amazon-wishlist-button-color').val();
                                var buttonTextColor = $('#easy-amazon-wishlist-button-text-color').val();
                                var title = $('#easy-amazon-wishlist-h2-title').val();
                                var affiliateOption = $('#easy-amazon-wishlist-affiliate-option').is(":checked")
                                var affiliateId = $('#easy-amazon-wishlist-affiliate-id').val();
                                var paginationOption = $('#easy-amazon-wishlist-pagination-option').is(":checked");
                                var paginationLimit = $('#easy-amazon-wishlist-pagination-limit').val();

                                var wishlist = '<div id="easy-amazon-wishlist-list" style="' + backgroundColor + '"><h2 style="text-align:center;"><a href="' + ideaListUrl + '&tag=' + affiliateId + '" target="_blank">' + title + '</a></h2>';//'';

                                if (typeof wishlistArray !== 'undefined' && wishlistArray !== null) {

                                    $('#easy-amazon-wishlist-json').val(JSON.stringify(wishlistArray));

                                    for (var i = 0; i < wishlistArray.length; i++) {

                                        var display = "";
                                        if (paginationOption && (i >= paginationLimit)) {
                                            display = "display:none;";
                                        } else {
                                            display = "";
                                        }
                                        var link = "";
                                        var linkArray = [];

                                        link = wishlistArray[i]['link'];
                                        linkArray = link.split('&tag=');
                                        link = linkArray[0] + '&tag=' + affiliateId;

                                        wishlist = wishlist + '<div style="' + display + '" class="single-list-item"><div class="easy-amazon-wishlist-title"><a style="' + linkColor + '" title="' + wishlistArray[i]["name"] + '" href="' + link + '" target="_blank">' + wishlistArray[i]["name"] + '</a></div><div><div class="easy-amazon-wishlist-image-div"><a title="' + wishlistArray[i]["name"] + '" class="easy-amazon-wishlist-image" href="' + link + '" target="_blank"><img class="img-responsive" alt="' + wishlistArray[i]["name"] + '" src="' + wishlistArray[i]["img"] + '" /></a></div><div class="easy-amazon-wishlist-price-button"><div class="easy-amazon-wishlist-price">' + wishlistArray[i]["price"] + '</div><div class="easy-amazon-wishlist-button"><a style="' + linkColor + '" target="_blank" class="easy-amazon-wishlist-button" href="' + link + '" target="_blank"><button style="background-color:' + buttonColor + ';color:' + buttonTextColor + '" class="button">' + buttonText + '</button></a></div></div></div></div>';

                                    }
                                } else {
                                    wishlist = wishlist + '[EMPTY WISHLIST]';
                                    wishlistArray = [];
                                }

                                wishlist = wishlist + '<div class="pagination-row">';

                                if (paginationOption && Array.isArray(wishlistArray)) {
                                    var numItems = wishlistArray.length;
                                    var easyAmazonWishlistPagination = new EasyAmazonWishlistPagination(parseInt(paginationLimit), numItems);
                                    wishlist = wishlist + easyAmazonWishlistPagination.toString();
                                }
                                wishlist = wishlist + '</div></div>';

                                $('#wishlist-preview').html(wishlist).slideDown('slow', function (e) {
                                    //trigger all of the current display options
                                    $('#easy-amazon-wishlist-show-text-link').trigger('change');
                                    $('#easy-amazon-wishlist-text-link-char-limit').trigger('keyup');
                                    $('#easy-amazon-wishlist-show-image').trigger('change');
                                    $('#easy-amazon-wishlist-show-price').trigger('change');
                                    $('#easy-amazon-wishlist-show-button').trigger('change');
                                    $('#easy-amazon-wishlist-button-text').trigger('keyup');
                                    $('#easy-amazon-wishlist-background-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-text-link-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-button-color').trigger('keyup');
                                    $('#easy-amazon-wishlist-button-text-color').trigger('keyup');
                                    if (paginationOption) {
                                        easyAmazonWishlistPagination.createButtonEvents();
                                    }
                                });

                            }

                            //RETURN APP OBJECT
                            return easyAmazonWishlists;
                        }
                    )(jQuery, VanillaPicker);//END OF APPLICATION OBJECT


                    easyAmazonWishlistWidget.init();

                });

            </script>

            <?php
        }

//CSS for plugin settings Admin area
        $html = <<<EOHTML
<style type="text/css">
#wishlist-preview  {margin:0;padding: 0;}
#easy-amazon-wishlist-preview-button-div button {margin-top:10px;}
#easy-amazon-wishlist-h2-title {width:100%;}
table.form-table input, table.form-table select, table.form-table button {font-weight:normal;}
table.form-table th {font-weight:600;color:#23282d;}
table.form-table td {color:#23282d;vertical-align:top;font-size: 16px;padding:5px;}
table.form-table td.setting, table.form-table th.setting, table.form-table td.setting-title, table.form-table th.setting-title {vertical-align:middle}
table.form-table td.setting-title {text-align:right;padding-right:1em;}
table.form-table td.setting button {color: #0073aa;}
.text-input {width:100%;min-width:400px;}
@keyframes blink {50% { color: transparent }}
.easyAmazonWishlistLoader__dot { animation: 1s blink infinite }
.easyAmazonWishlistLoader__dot:nth-child(2) { animation-delay: 250ms }
.easyAmazonWishlistLoader__dot:nth-child(3) { animation-delay: 500ms }
.easyAmazonWishlistPagination {font-weight:bold;text-decoration:underline;cursor:pointer;}
.easyAmazonWishlistPagination:hover {font-weight:normal;}
.easyAmazonWishlistPagination.current {text-decoration:none;font-weight:normal;}
.easy-amazon-wishlist-modified {display: inline-block; position: relative; height: 33px; line-height: 33px; padding: 0 15px; font-size: 15px; color: white !important; text-decoration: none !important; text-shadow: 0 -1px rgba(0, 0, 0, 0.3);border: 2px solid;border-radius: 7px;outline: 0;-webkit-box-shadow: 0 2px 1px rgba(0, 0, 0, 0.25);box-shadow: 0 2px 1px rgba(0, 0, 0, 0.25);background: #d02e17;border-color: #942110 #902010 #741a0d;background-image: -webkit-linear-gradient(top, #e74a29 0%, #e6451b 50%, #d02e17 50%, #b3150b 100%);background-image: -moz-linear-gradient(top, #e74a29 0%, #e6451b 50%, #d02e17 50%, #b3150b 100%);background-image: -o-linear-gradient(top, #e74a29 0%, #e6451b 50%, #d02e17 50%, #b3150b 100%);background-image: linear-gradient(to bottom, #e74a29 0%, #e6451b 50%, #d02e17 50%, #b3150b 100%);}
.easy-amazon-wishlist-modified:active {background: black;background-image: -webkit-linear-gradient(top, #a9110b 0%, #de3819 60%, #e63b1b 100%);background-image: -moz-linear-gradient(top, #a9110b 0%, #de3819 60%, #e63b1b 100%);background-image: -o-linear-gradient(top, #a9110b 0%, #de3819 60%, #e63b1b 100%);background-image: linear-gradient(to bottom, #a9110b 0%, #de3819 60%, #e63b1b 100%);}
.easy-amazon-wishlist-modified:hover {color:black !important;}
.popup-parent {pointer:cursor;width:30px;height:30px;border:1px solid black;}
EOHTML;
        if (get_option('easy-amazon-wishlist-show-text-link') != 1) //previous options should already be applied in style css in json
            $html .= '.easy-amazon-wishlist-title{display:none;}';
        if (get_option('easy-amazon-wishlist-show-image') != 1)
            $html .= '.easy-amazon-wishlist-image{display:none;}';
        if (get_option('easy-amazon-wishlist-show-price') != 1)
            $html .= '.easy-amazon-wishlist-price{display:none;}';
        if (get_option('easy-amazon-wishlist-show-button') != 1)
            $html .= '.easy-amazon-wishlist-button{display:none;}';
        if (get_option('easy-amazon-wishlist-affiliate-option') != 1)
            $html .= '.affiliate-row{display:none;}';
        if (get_option('easy-amazon-wishlist-pagination-option') != 1)
            $html .= '.pagination-input-row{display:none;}';
        $html .= <<<EOHTML
</style>
<form id="options-form" method="post" action="options.php">
<div>
<h2>
EOHTML;
        $html .= htmlentities(__('Easy Amazon Wishlist', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ' - ' . htmlentities(__('Options', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</h2>
<h3>
EOHTML;
        $html .= htmlentities(__('Instructions', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</h3>
<p>
EOHTML;
        $html .= htmlentities(__('Update the Amazon website country', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ' (amazon.com ' . htmlentities(__('for', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ' US,  amazon.co.uk ' . htmlentities(__('for', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ' England, ' . htmlentities(__('etc', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . '.), ' . htmlentities(__('find your amazon list url', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ', ' . ' (' . htmlentities(__('and click', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . '"' . htmlentities(__('update', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . '"), ' . htmlentities(__('and make sure to activate the', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . ' <strong>' . htmlentities(__('Easy Amazon Wishlist', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8") . '</strong> ' . htmlentities(__('plugin and place the widget in your page', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
.</p>

EOHTML;
        $html .= wp_nonce_field('update-options');
        $html .= <<<EOHTML
<table width="100%" border="0" class="form-table">

        <td style="font-weight:600;">
EOHTML;
        $html .= <<<EOHTML
        
        <table border="0">
  
        <tr valign="top">
        <th class="setting-title">
EOHTML;
        $html .= htmlentities(__('Specify Amazon Website', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
:</th>
        <td class="setting">
        <select name="easy-amazon-wishlist-websites" id="easy-amazon-wishlist-websites">
EOHTML;
        foreach (easy_amazon_wishlist_amazonWebsites() as $key => $title) {
            $selected = '';
            if (get_option('easy-amazon-wishlist-websites') == $key)
                $selected = 'selected="selected"';
            $html .= '<option value="' . $key . '" ' . $selected . '>' . $title . '</option>';
        }
        $html .= <<<EOHTML
        </select>
        </td>
        </tr>
        
        <tr valign="top">
        <th class="setting-title">
EOHTML;
        $html .= htmlentities(__('List Type', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
:</th>
        <td class="setting">
            <select name="easy-amazon-wishlist-list-type" id="easy-amazon-wishlist-list-type">
            <option value="">
EOHTML;
        $html .= htmlentities(__('Please Choose', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
            </option>
            <option value="amazon-wishlist"
EOHTML;
        if (get_option('easy-amazon-wishlist-list-type') == 'amazon-wishlist') {
            $html = $html . ' selected="selected"';
        }
        $html .= <<<EOHTML
>
EOHTML;
        $html .= htmlentities(__('Amazon Wishlist', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
        </option>
        <option value="amazon-idea-list"
EOHTML;
        if (get_option('easy-amazon-wishlist-list-type') == 'amazon-idea-list') {
            $html = $html . ' selected="selected"';
        }
        $html .= <<<EOHTML
>
EOHTML;
        $html .= htmlentities(__('Amazon Idea List', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
        </option>
        </select>
        </td>
        </tr>
      
        <tr id="easy-amazon-wishlist-div"
EOHTML;
        if (get_option('easy-amazon-wishlist-list-type') !== 'amazon-wishlist') {
            $html .= ' style="display:none;" ';
        }
        $html .= <<<EOHTML
>
            <th class="setting-title" scope="row"
EOHTML;
        $html .= '<strong>' . htmlentities(__('Amazon Wishlist Url', 'EasyAmazonWishlist'),
                ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</strong>:</th>
        <td class="setting"><input class="text-input" name="easy-amazon-wishlist-list-url" type="text" id="easy-amazon-wishlist-list-url" 
value="
EOHTML;
        $html .= get_option('easy-amazon-wishlist-list-url');
        $html .= <<<EOHTML
" /><br>(ex.https://www.amazon.com/hz/wishlist/ls/20YXDMUE7M8AD?&sort=default)<div id="easy-amazon-wishlist-preview-button-div"><button style="cursor:pointer;" id="easy-amazon-wishlist-preview-button">
EOHTML;
        $html .= htmlentities(__('Preview Wishlist', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</button></div></td>
</tr>
      
      <tr id="easy-amazon-idea-list-div"
EOHTML;
        if (get_option('easy-amazon-wishlist-list-type') !== 'amazon-idea-list') {
            $html .= ' style="display:none;" ';
        }
        $html .= <<<EOHTML
>
<th class="setting-title" scope="row"
EOHTML;
        $html .= '<strong>' . htmlentities(__('Amazon Idea List Url', 'EasyAmazonWishlist'),
                ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</strong>:</th>
<td class="setting"><input class="text-input" name="easy-amazon-wishlist-idea-list-url" type="text" id="easy-amazon-wishlist-idea-list-url" value="
EOHTML;
        $html .= get_option('easy-amazon-wishlist-idea-list-url');
        $html .= <<<EOHTML
" /><br>(ex. https://www.amazon.com/ideas/amzn1.account.AHWEHXLSUKTGPJIDYXYVN3GRIVEQ/3LXYXW2B49BVA?type=explore&ref=idea_cp_vl_ov_d)<div id="easy-amazon-wishlist-idea-list-preview-button-div"><button style="cursor:pointer;" id="easy-amazon-wishlist-idea-list-preview-button">
EOHTML;
        $html .= htmlentities(__('Preview Idea List', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</button></div></td>
</tr>

<tr><td colspan="2" valign="top">
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="easy-amazon-wishlist-websites, easy-amazon-wishlist-list-type, easy-amazon-wishlist-list-url, easy-amazon-wishlist-idea-list-url, easy-amazon-wishlist-background-color,easy-amazon-wishlist-h2-title, easy-amazon-wishlist-show-text-link, easy-amazon-wishlist-text-link-color,easy-amazon-wishlist-show-image, easy-amazon-wishlist-show-price, easy-amazon-wishlist-show-button, easy-amazon-wishlist-button-color,easy-amazon-wishlist-button-text,easy-amazon-wishlist-button-text-color, easy-amazon-wishlist-text-link-char-limit, easy-amazon-wishlist-affiliate-option, easy-amazon-wishlist-affiliate-id, easy-amazon-wishlist-pagination-option, easy-amazon-wishlist-pagination-limit, easy-amazon-wishlist-json" />
<h3>Display Settings</h3></td></tr>
<tr><td class="setting-title">List Title</td><td class="setting"><input type="text" id="easy-amazon-wishlist-h2-title" name="easy-amazon-wishlist-h2-title" value="
EOHTML;
        //************************* Initial Admin Area Display *******************************/
        $html .= get_option('easy-amazon-wishlist-h2-title');
        $html .= <<<EOHTML
"  /></td></tr>
<tr><td class="setting-title">List Background Color</td><td class="setting"><input type="hidden" id="easy-amazon-wishlist-background-color" name="easy-amazon-wishlist-background-color" value="
EOHTML;
        if (get_option('easy-amazon-wishlist-background-color')) {
            $html .= get_option('easy-amazon-wishlist-background-color');
        } else {
            $html .= '#c4c4c4';
        }
        $html .= <<<EOHTML
"  /> <div id="easy-amazon-wishlist-background-color-picker" class="popup-parent" style="background-color:
EOHTML;
        if (get_option('easy-amazon-wishlist-background-color')) {
            $html .= get_option('easy-amazon-wishlist-background-color');
        } else {
            $html .= '#c4c4c4';
        }
        $html .= <<<EOHTML
;"></div>
</td></tr>
<tr><td class="setting-title">Show Text Link</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-show-text-link') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-show-text-link" name="easy-amazon-wishlist-show-text-link" value="1"  /></td></tr>
 <tr><td class="setting-title">Text Link Color</td><td class="setting"><input type="hidden" id="easy-amazon-wishlist-text-link-color" name="easy-amazon-wishlist-text-link-color" value="
EOHTML;
        if (get_option('easy-amazon-wishlist-text-link-color')) {
            $html .= get_option('easy-amazon-wishlist-text-link-color');
        } else {
            $html .= '#0073aa';
        }
        $html .= <<<EOHTML
"  /> <div id="easy-amazon-wishlist-text-link-color-picker" class="popup-parent" style="background-color:
EOHTML;
        if (get_option('easy-amazon-wishlist-text-link-color')) {
            $html .= get_option('easy-amazon-wishlist-text-link-color');
        } else {
            $html .= '#0073aa';
        }
        $html .= <<<EOHTML
;"></div>
</td></tr>
<tr><td class="setting-title">Set Char Limit on Link</td><td class="setting"><input type="text" id="easy-amazon-wishlist-text-link-char-limit" name="easy-amazon-wishlist-text-link-char-limit" value="
EOHTML;
        $html .= get_option('easy-amazon-wishlist-text-link-char-limit');
        $html .= <<<EOHTML
"  /></td></tr>
<tr><td class="setting-title">Show Image</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-show-image') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-show-image" name="easy-amazon-wishlist-show-image" value="1"  /></td></tr>
<tr><td class="setting-title">Show Price</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-show-price') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-show-price" name="easy-amazon-wishlist-show-price" value="1"  /></td></tr>
<tr><td class="setting-title">Show Button</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-show-button') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-show-button" name="easy-amazon-wishlist-show-button" value="1"  /></td></tr>
 <tr><td class="setting-title">Button Color</td><td class="setting"><input type="hidden" id="easy-amazon-wishlist-button-color" name="easy-amazon-wishlist-button-color" value="
EOHTML;
        if (get_option('easy-amazon-wishlist-button-color')) {
            $html .= get_option('easy-amazon-wishlist-button-color');
        } else {
            $html .= '#f7f7f7';
        }
        $html .= <<<EOHTML
"  /> <div id="easy-amazon-wishlist-button-color-picker" class="popup-parent" style="background-color:
EOHTML;
        if (get_option('easy-amazon-wishlist-button-color')) {
            $html .= get_option('easy-amazon-wishlist-button-color');
        } else {
            $html .= '#f7f7f7';
        }
        $html .= <<<EOHTML
;"></div></td></tr>
<tr><td class="setting-title">Button Text</td><td class="setting"><input type="text" id="easy-amazon-wishlist-button-text" name="easy-amazon-wishlist-button-text" value="
EOHTML;
        $html .= get_option('easy-amazon-wishlist-button-text');
        $html .= <<<EOHTML
"  /></td></tr>

<tr><td class="setting-title">Button Text Color</td><td class="setting"><input type="hidden" id="easy-amazon-wishlist-button-text-color" name="easy-amazon-wishlist-button-text-color" value="
EOHTML;
        if (get_option('easy-amazon-wishlist-button-text-color')) {
            $html .= get_option('easy-amazon-wishlist-button-text-color');
        } else {
            $html .= '#555';
        }
        $html .= <<<EOHTML
"  /> <div id="easy-amazon-wishlist-button-text-color-picker" class="popup-parent" style="background-color:
EOHTML;
        if (get_option('easy-amazon-wishlist-button-text-color')) {
            $html .= get_option('easy-amazon-wishlist-button-text-color');
        } else {
            $html .= '#555';
        }
        $html .= <<<EOHTML
;"></div></td></tr>
<tr><td class="setting-title">Add Pagination</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-pagination-option') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-pagination-option" name="easy-amazon-wishlist-pagination-option" value="1"  /></td></tr>
<tr class="pagination-input-row"><td class="setting-title">Pagination Limit</td><td class="setting"><input type="text" id="easy-amazon-wishlist-pagination-limit" name="easy-amazon-wishlist-pagination-limit" value="
EOHTML;
        $paginationLimit = get_option('easy-amazon-wishlist-pagination-limit');
        $html .= $paginationLimit;
        $html .= <<<EOHTML
"  /></td></tr>
<tr><td class="setting-title">Add Affiliate ID</td><td class="setting"><input
EOHTML;
        if (get_option('easy-amazon-wishlist-affiliate-option') == 1) {
            $html .= ' checked="checked" ';
        }
        $html .= <<<EOHTML
 type="checkbox" id="easy-amazon-wishlist-affiliate-option" name="easy-amazon-wishlist-affiliate-option" value="1"  /></td></tr>
<tr class="affiliate-row"><td class="setting-title">Affiliate ID</td><td class="setting"><input type="text" id="easy-amazon-wishlist-affiliate-id" name="easy-amazon-wishlist-affiliate-id" value="
EOHTML;
        $affiliateId = get_option('easy-amazon-wishlist-affiliate-id');
        if (!$affiliateId) {
            switch (get_option('easy-amazon-wishlist-websites')) {
                case "com":
                    $affiliateId = "wwwwebmastern-20";
                    break;
                case "co.uk":
                    $affiliateId = "wwwwebmastern-21";
                    break;
                case "de":
                    $affiliateId = "wwwwebmast03b-21";
                    break;
                case "fr":
                    $affiliateId = "wwwwebmaste0d-21";
                    break;
                case "ca":
                    $affiliateId = "wwwwebmaste0d-20";
                    break;
                case "es":
                    $affiliateId = "wwwwebmaste05-21";
                    break;
                case "it":
                    $affiliateId = "wwwwebmaste02-21";
                    break;
                case "in":
                    $affiliateId = "webmaste-21";
                    break;
                default:
                    $affiliateId = "wwwwebmastern-20";
                    break;
            }
            /*        'co.uk' => 'amazon.co.uk', //tag=wwwwebmastern-21
    'de' => 'amazon.de', //tag=wwwwebmast03b-21
    'fr' => 'amazon.fr', //tag=wwwwebmaste0d-21
    'co.jp' => 'amazon.co.jp', //TODO problem logging in
    'ca' => 'amazon.ca', //tag=wwwwebmaste0d-20
    'es' => 'amazon.es', //tag=wwwwebmaste05-21
    'it' => 'amazon.it', //tag=wwwwebmaste02-21
    'cn' => 'amazon.cn', //TODO problem logging in
    'in' => 'amazon.in', //tag=webmaste-21*/
            //https://www.amazon.com/ideas/amzn1.account.AHWEHXLSUKTGPJIDYXYVN3GRIVEQ/3LXYXW2B49BVA/ref=as_li_ss_tl?ref=idea_cp_vl_ov_d&linkCode=ll2&tag=wwwwebmastern-20&linkId=ad51b9630857a88669dd80359b958c35&language=en_US
        }
        $html .= $affiliateId;
        $html .= <<<EOHTML
"  /></td></tr>
 <input type="hidden" id="easy-amazon-wishlist-json" name="easy-amazon-wishlist-json" value='
EOHTML;
        $wishlist = get_option('easy-amazon-wishlist-json');
        if ($wishlist) {

            $html .= str_replace ("'","&apos;",$wishlist);
        } else {
            $html .= '[]';
        }
        $html .= <<<EOHTML
'  />
<tr><td style="text-align:center;" colspan="2">
<p style="width:250px;margin-left:auto;margin-right:auto;">
<input id="easy-amazon-wishlist-update" class="easy_amazon_wishlist_submit_button" style="cursor:pointer;" name="easy-amazon-wishlist-update" type="submit" value="Save Changes" /><br>(
EOHTML;
        $html .= htmlentities(__('saves your changes', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
)</p></td></tr>
</table>
        </td><td rowspan="13" style="vertical-align:top;">

<h3>
EOHTML;
        $html .= htmlentities(__('Your Wishlist Preview', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
        $html .= <<<EOHTML
</h3>
<table border="0" style="border-collapse:collapse">
	<tr>
		<td id="wishlist-preview">
EOHTML;
        $html .= easy_amazon_wishlist();
        $html .= <<<EOHTML
</td>
	</tr>
</table></td>
</tr></table>
</form>
</div>
EOHTML;
        echo $html;
    }
}

register_activation_hook(__FILE__, 'easy_amazon_wishlist_install');
register_deactivation_hook(__FILE__, 'easy_amazon_wishlist_remove');

function easy_amazon_wishlist_install()
{
    update_option("easy-amazon-wishlist-list-type", '', '', 'yes');
    update_option("easy-amazon-wishlist-list-url", '', '', 'yes');
    update_option("easy-amazon-wishlist-idea-list-url", '', '', 'yes');
    //add_option("easy-amazon-wishlist-layout", $default, '', 'yes');
    update_option("easy-amazon-wishlist-websites", 'com', '', 'yes');
    //add_option("easy-amazon-wishlist-use-unsorted-list", '1', '', 'yes');
    update_option("easy-amazon-wishlist-h2-title", '', '', 'yes');
    update_option("easy-amazon-wishlist-show-text-link", '1', '', 'yes');
    update_option("easy-amazon-wishlist-show-image", '1', '', 'yes');
    update_option("easy-amazon-wishlist-show-price", '1', '', 'yes');
    update_option("easy-amazon-wishlist-show-button", '1', '', 'yes');
    update_option("easy-amazon-wishlist-button-text", __('More Info', 'EasyAmazonWishlist'), ENT_QUOTES, "UTF-8");
    update_option("easy-amazon-wishlist-text-link-char-limit", '', '', 'yes');
    update_option("easy-amazon-wishlist-background-color", '', '', 'yes');
    update_option("easy-amazon-wishlist-text-link-color", '', '', 'yes');
    update_option("easy-amazon-wishlist-button-color", '', '', 'yes');
    update_option("easy-amazon-wishlist-button-text-color", '', '', 'yes');
    update_option("easy-amazon-wishlist-affiliate-option", '', '', 'yes');
    update_option("easy-amazon-wishlist-affiliate-id", '', '', 'yes');
    update_option("easy-amazon-wishlist-pagination-option", '', '', 'yes');
    update_option("easy-amazon-wishlist-pagination-limit", '', '', 'yes');
    update_option("easy-amazon-wishlist-json", '', '', 'yes');
}

function easy_amazon_wishlist_remove()
{
    delete_option('easy-amazon-wishlist-list-type');
    delete_option('easy-amazon-wishlist-list-url');
    delete_option('easy-amazon-wishlist-idea-list-url');
    delete_option('easy-amazon-wishlist-websites');
    delete_option('easy-amazon-wishlist-h2-title');
    //delete_option('easy-amazon-wishlist-use-unsorted-list');
    delete_option('easy-amazon-wishlist-show-text-link');
    delete_option('easy-amazon-wishlist-show-image');
    delete_option('easy-amazon-wishlist-show-price');
    delete_option('easy-amazon-wishlist-show-button');
    delete_option('easy-amazon-wishlist-button-text');
    delete_option('easy-amazon-wishlist-text-link-char-limit');
    delete_option('easy-amazon-wishlist-background-color');
    delete_option('easy-amazon-wishlist-text-link-color');
    delete_option('easy-amazon-wishlist-button-color');
    delete_option('easy-amazon-wishlist-button-text-color');
    delete_option('easy-amazon-wishlist-affiliate-option');
    delete_option('easy-amazon-wishlist-affiliate-id');
    delete_option('easy-amazon-wishlist-pagination-option');
    delete_option('easy-amazon-wishlist-pagination-class');
    delete_option('easy-amazon-wishlist-json');
}

class Easy_Amazon_Wishlist_Widget extends WP_Widget
{

    function Easy_Amazon_Wishlist_Widget()
    {
        parent::WP_Widget(false, $name = 'Easy Amazon Wishlist Widget');
    }

    function widget($args, $instance)
    {
        extract($args); //taking out title crap
        //$title = apply_filters('widget_title', $instance['title']);
        echo $before_widget;
        /*if ($title) {
            echo $before_title . $title . $after_title;
            */ ?>
        <!--div class="my_textbox"-->
        <?php echo easy_amazon_wishlist(); ?>
        <!--/div-->
        <?php
        /*}*/

        echo $after_widget;
    }

    function update($new_instance, $old_instance)
    {
        $instance = $old_instance;
        $instance['title'] = strip_tags($new_instance['title']);
        return $instance;
    }

    function form($instance)
    {
        //Set up some default widget settings.
        $defaults = array('title' => htmlentities(__('Amazon Wishlist', 'Amazon Wishlist'), ENT_QUOTES, "UTF-8"));
        $instance = wp_parse_args((array)$instance, $defaults);

        //Widget Title: Text Input.
        ?>
        <p>
            <label for="<?php echo $this->get_field_id('title'); ?>"><?php htmlentities(_e('Title', 'My Amazon Wishlist'), ENT_QUOTES, "UTF-8"); ?>
                :</label>
            <input id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>"
                   value="<?php echo $instance['title']; ?>" style="text-align:center;width:100%;"/>
        </p>
        <?php
    }

}

add_action('widgets_init', 'register_Easy_Amazon_Wishlist_Widget');

function register_Easy_Amazon_Wishlist_Widget()
{
    if (!function_exists('get_plugin_data')) {
        require_once(ABSPATH . 'wp-admin/includes/plugin.php');
    }
    $plugin_data = get_plugin_data(__FILE__);

    wp_register_style('easy_amazon_wishlist_style', plugins_url('style.css', __FILE__));
    wp_register_script('easy_amazon_wishlist_script', plugins_url('script.js', __FILE__));
    wp_enqueue_style('easy_amazon_wishlist_style', $plugin_data['Version']);
    wp_enqueue_script('easy_amazon_wishlist_script', ['jquery', 'jquery-ui-core'], "1.0"); //$plugin_data['Version']
    register_widget('Easy_Amazon_Wishlist_Widget');
}

//REQUIRED CLASSES AND FUNCTIONS
class EasyAmazonWishlistEmailAddressValidator
{

    public function check_email_address($strEmailAddress)
    {
        if (preg_match('/[\x00-\x1F\x7F-\xFF]/', $strEmailAddress)) {
            return false;
        }
        if (!$this->check_text_length($strEmailAddress, 3, 256)) {
            return false;
        }
        $intAtSymbol = strrpos($strEmailAddress, '@');
        if ($intAtSymbol === false) {
            return false;
        }
        $arrEmailAddress[0] = substr($strEmailAddress, 0, $intAtSymbol);
        $arrEmailAddress[1] = substr($strEmailAddress, $intAtSymbol + 1);
        $arrTempAddress[0] = preg_replace('/\./'
            , ''
            , $arrEmailAddress[0]);
        $arrTempAddress[0] = preg_replace('/"[^"]+"/'
            , ''
            , $arrTempAddress[0]);
        $arrTempAddress[1] = $arrEmailAddress[1];
        $strTempAddress = $arrTempAddress[0] . $arrTempAddress[1];
        if (strrpos($strTempAddress, '@') !== false) {
            return false;
        }
        if (!$this->check_local_portion($arrEmailAddress[0])) {
            return false;
        }
        if (!$this->check_domain_portion($arrEmailAddress[1])) {
            return false;
        }
        return true;
    }

    protected function check_local_portion($strLocalPortion)
    {
        if (!$this->check_text_length($strLocalPortion, 1, 64)) {
            return false;
        }
        $arrLocalPortion = explode('.', $strLocalPortion);
        for ($i = 0, $max = sizeof($arrLocalPortion); $i < $max; $i++) {
            if (!preg_match('.^('
                . '([A-Za-z0-9!#$%&\'*+/=?^_`{|}~-]'
                . '[A-Za-z0-9!#$%&\'*+/=?^_`{|}~-]{0,63})'
                . '|'
                . '("[^\\\"]{0,62}")'
                . ')$.'
                , $arrLocalPortion[$i])) {
                return false;
            }
        }
        return true;
    }

    protected function check_domain_portion($strDomainPortion)
    {
        if (!$this->check_text_length($strDomainPortion, 1, 255)) {
            return false;
        }
        if (preg_match('/^(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])'
                . '(\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])){3}$/'
                , $strDomainPortion) ||
            preg_match('/^\[(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])'
                . '(\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9]?[0-9])){3}\]$/'
                , $strDomainPortion)) {
            return true;
        } else {
            $arrDomainPortion = explode('.', $strDomainPortion);
            if (sizeof($arrDomainPortion) < 2) {
                return false;
            }
            for ($i = 0, $max = sizeof($arrDomainPortion); $i < $max; $i++) {
                if (!$this->check_text_length($arrDomainPortion[$i], 1, 63)) {
                    return false;
                }
                if (!preg_match('/^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|'
                    . '([A-Za-z0-9]+))$/', $arrDomainPortion[$i])) {
                    return false;
                }
                if ($i == $max - 1) {
                    if (strlen(preg_replace('/[0-9]/', '', $arrDomainPortion[$i])) <= 0) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

    protected function check_text_length($strText, $intMinimum, $intMaximum)
    {
        // Minimum and maximum are both inclusive
        $intTextLength = strlen($strText);
        if (($intTextLength < $intMinimum) || ($intTextLength > $intMaximum)) {
            return false;
        } else {
            return true;
        }
    }

}

function easyAmazonWishlistDisplayPreviewList($title, $list_type, $wishlist_id, $idea_list_url, $amazon_store, $wishlistArray, $show_text_link, $show_image, $show_price, $show_button, $button_text, $text_link_char_limit, $affiliate_option, $affiliate_id, $pagination_option, $pagination_limit, $background_color, $link_color, $button_color, $button_text_color)
{

    //TODO: test using url given and adding affiliate id
    switch ($list_type) {
        case "amazon-wishlist":
            $link = 'https://www.amazon.' . $amazon_store . '/gp/registry/wishlist/' . $wishlist_id . '/?ref=wl_share&sort=default&tag=' . $affiliate_id;
            break;
        case "amazon-idea-list":
            $link = $idea_list_url . '&tag=' . $affiliate_id;
            break;
        default:
            $link = 'https://www.amazon.' . $amazon_store . '/gp/registry/wishlist/' . $wishlist_id . '/?ref=wl_share&sort=default&tag=' . $affiliate_id;
            break;
    }

    $wishlistHtml = '<div id="easy-amazon-wishlist-list" style="background-color:' . $background_color . ';"><h2><a href="' . $link . '" target="_blank">' . $title . '</a></h2>';

    if (is_array($wishlistArray)) {
        for ($i = 0; $i < count($wishlistArray); $i++) {

            $wishlistHtml = $wishlistHtml . '<div class="single-list-item" style="';

            if ($pagination_option && (int)$pagination_limit && ($i >= (int)$pagination_limit)) {
                $wishlistHtml = $wishlistHtml . 'display:none;';
            }

            $wishlistHtml = $wishlistHtml . '"><div style="';

            if (!$show_text_link) {
                $wishlistHtml = $wishlistHtml . 'display:none;';
            }
            if (!$affiliate_option) {
                $link = $wishlistArray[$i]->link;
            } else {
                $linkArray = explode('&tag=', $wishlistArray[$i]->link);
                $link = $linkArray[0] . '&tag=' . $affiliate_id;
            }
            //Not sure why the single quotes aren't already encoded
            $wishlistArray[$i]->name = htmlspecialchars($wishlistArray[$i]->name, ENT_QUOTES, "UTF-8", false);
            $wishlistHtml = $wishlistHtml . '" class="easy-amazon-wishlist-title"><a title="' . $wishlistArray[$i]->name . '" href="' . $link . '" target="_blank">';
            if (isset($text_link_char_limit) && intval($text_link_char_limit)) {
                $substr = substr($wishlistArray[$i]->name, 0, intval($text_link_char_limit));
                if (strlen($substr) < strlen($wishlistArray[$i]->name)) {
                    $substr = $substr . '...';
                }
                $wishlistHtml = $wishlistHtml . $substr;
            } else {
                $wishlistHtml = $wishlistHtml . $wishlistArray[$i]->name;
            }
            $wishlistHtml = $wishlistHtml . '</a></div><div><div class="easy-amazon-wishlist-image-div"><a style="';
            if (!$show_image) {
                $wishlistHtml = $wishlistHtml . 'display:none;';
            }
            $wishlistHtml = $wishlistHtml . 'color:' . $link_color . ';" class="easy-amazon-wishlist-image" href="' . $link . '" target="_blank"><img class="img-responsive" title="' . $wishlistArray[$i]->name . '!" alt="' . $wishlistArray[$i]->name . '" src="' . $wishlistArray[$i]->img . '" /></a></div><div class="easy-amazon-wishlist-price-button"><div class="easy-amazon-wishlist-price" style="';
            if (!$show_price) {
                $wishlistHtml = $wishlistHtml . 'display:none;';
            }
            $wishlistHtml = $wishlistHtml . '">' . $wishlistArray[$i]->price . '</div><div class="easy-amazon-wishlist-button"><a style="';
            if (!$show_button) {
                $wishlistHtml = $wishlistHtml . 'display:none;';
            }
            $wishlistHtml = $wishlistHtml . '" class="easy-amazon-wishlist-button" href="' . $link . '" target="_blank"><button style="background-color:' . $button_color . ';color:' . $button_text_color . ';" class="button">' . $button_text . '</button></a></div></div></div></div>';
        }
    }
    //always have pagination row, but start out hiding
    if ($pagination_option && $pagination_limit) {
        $paginationClass = plugin_dir_path(__FILE__) . 'Pagination.php';
        require_once($paginationClass);

        $paginationNav = new Pagination($wishlistArray, $pagination_limit);
        $wishlistHtml = $wishlistHtml . '<div class="pagination-row">' . $paginationNav . '</div>';
        $wishlistHtml = $wishlistHtml . '<script>';
        if (!$wishlistArray) $wishlistArray = [];
        $wishlistHtml = $wishlistHtml . 'var easyAmazonWishlistPagination = new EasyAmazonWishlistPagination(' . $pagination_limit . ', '.count($wishlistArray).');easyAmazonWishlistPagination.createButtonEvents();</script>';
    } else{
        $wishlistHtml = $wishlistHtml . '<div class="pagination-row"></div>';
    }

    $wishlistHtml = $wishlistHtml . '</div>';

    /*$file = plugin_dir_path( __FILE__ )  . 'wishlist.html.cache';

    file_put_contents($file, $wishlistHtml);*/

    return $wishlistHtml;
}

function easy_amazon_wishlist_amazonWebsites()
{
    $websites = array(
        'com' => 'amazon.com', //tag=wwwwebmastern-20
        'co.uk' => 'amazon.co.uk', //tag=wwwwebmastern-21
        'de' => 'amazon.de', //tag=wwwwebmast03b-21
        'fr' => 'amazon.fr', //tag=wwwwebmaste0d-21
        'co.jp' => 'amazon.co.jp', //TODO problem logging in
        'ca' => 'amazon.ca', //tag=wwwwebmaste0d-20
        'es' => 'amazon.es', //tag=wwwwebmaste05-21
        'it' => 'amazon.it', //tag=wwwwebmaste02-21
        'cn' => 'amazon.cn', //TODO problem logging in
        'in' => 'amazon.in', //tag=webmaste-21
    );

    return $websites;
}

function easy_amazon_wishlist_amazonLocales()
{
    $locales = array(
        'com' => 'US',
        'co.uk' => 'GB',
        'de' => 'DE',
        'fr' => 'FR',
        'co.jp' => 'JP',
        'ca' => 'CA',
        'es' => 'ES',
        'cn' => 'CN',
        'it' => 'IT',
        'in' => 'IN',
    );

    return $locales;
}
