<?php
session_start();
//TODO remove error reporting and pull from url
error_reporting(0); //turns off error reporting

//ini_set('xdebug.var_display_max_depth', '2');
//ini_set("log_errors", 1);
//ini_set("error_log", plugin_dir_path(__FILE__) . "php-error.log");

//https://simplehtmldom.sourceforge.io/manual_api.htm

if (isset($_POST['csrf_token']) && $_POST['csrf_token'] === $_SESSION['csrf_token']) {

//scrape idea list on Amazon
    $ideaListUrl = isset($_REQUEST['ideaListUrl']) && (strlen($_REQUEST['ideaListUrl']) < 240) ? urldecode($_REQUEST['ideaListUrl']) : null;
    $country = isset($_REQUEST['country']) && (strlen($_REQUEST['country']) < 40) ? htmlspecialchars($_REQUEST['country']) : null;
    $headers = getallheaders();

    include("simple_html_dom.php");

//amazon idea list url passedin locally

//$url = "https://www.amazon.com/ideas/amzn1.account.AHWEHXLSUKTGPJIDYXYVN3GRIVEQ/3LXYXW2B49BVA?ref=idea_cp_vl_ov_d";

    $listItems = [];
error_log('entering try');
    try {
        error_log($ideaListUrl);

        $html = file_get_html($ideaListUrl, $headers);

        if ($html) {
error_log('got some html');
            $items = null;
            try {
                $items = $html->find('div.grid-item');
error_log('div.grid-item');

                if (!$items) {

                    $numItems = $html->find('#viewItemCount', 0)->attr['value'];

                    $items = $html->find('li.wl-grid-item');

                    $listItems = loadUlGrid($items, $country);
                } else {
                    $listItems = loadDivGrid($items, $country);
                }
            } catch (Exception $e) {
                error_log($e->getMessage());
            }

        } else {
            error_log('readAmazonIdealist: html not returned for ' . $ideaListUrl);
            error_log($html);
        }
    } catch (Exception $e) {
        error_log('Error getting Idea List from Amazon: ' . $e->getMessage());
    }

    $json = json_encode($listItems);

//print_r($items);
    // No need to do this twice..it's already done in the callback
    //$cache_file = __DIR__ . DIRECTORY_SEPARATOR . 'wishlist.json.cache.temp';
    //$success = file_put_contents($cache_file, $json, FILE_TEXT);

    echo $json;

} else {
        $response = ["error" => "CSRF Error"];
        echo json_encode($response);
}

function loadUlGrid($items, $country){
    $listItems = null;

    foreach ($items as $item) {
        $singleItem = [];

        $singleItem['id'] = substr($item->attr['id'], 5);
        $image = $item->find('img', 0);
        if ($image) {
            $attributes = $image->attr;
            $singleItem['name'] = htmlspecialchars($attributes['alt'], ENT_QUOTES, "UTF-8", false);
            $singleItem['img'] = $attributes['src'];
        } else {
            $singleItem['name'] = "No Name";
            $singleItem['img'] = "";
        }

        $price = $item->find('#grid-item-price-' . $singleItem['id'] . ' span.a-offscreen', 0);

        if ($price) {
            $singleItem['price'] = $price->plaintext;
        } else {
            $singleItem['price'] = "NO PRICE";
        }

        $link = $item->find('a', 0);

        if ($link) {
            $singleItem['link'] = "https://amazon." . $country . $link->attr['href'];
        } else {
            $singleItem['link'] = "";
        }

        $listItems[] = $singleItem;

    }

    return $listItems;
}

function loadDivGrid($items, $country){
    $listItems = null;

        foreach ($items as $item) {
            $singleItem = [];

            $singleItem['id'] = substr($item->attr['id'], 5);
            $image = $item->find('img', 0);
            if ($image) {
                $attributes = $image->attr;
                $singleItem['name'] = htmlspecialchars($attributes['alt'], ENT_QUOTES, "UTF-8", false);
                $singleItem['img'] = $attributes['src'];
            } else {
                $singleItem['name'] = "No Name";
                $singleItem['img'] = "";
            }

            $price = $item->find('#itemPrice_' . $singleItem['id'] . ' span.a-offscreen', 0);

            if ($price) {
                $singleItem['price'] = $price->plaintext;
            } else {
                $singleItem['price'] = "NO PRICE";
            }

            $link = $item->find('a', 0);

            if ($link) {
                $singleItem['link'] = "https://amazon." . $country . $link->attr['href'];
            } else {
                $singleItem['link'] = "";
            }

            $listItems[] = $singleItem;
        }

    return $listItems;
}