<?php
session_start();

error_reporting(0); //turns off error reporting

ini_set('xdebug.var_display_max_depth', '2');
ini_set("log_errors", 1);
ini_set("error_log", plugin_dir_path(__FILE__) . "php-error.log");
//TODO save cache file with wishlist ID or Idea List ID .. per page/category/post?

//https://simplehtmldom.sourceforge.io/manual_api.htm


include("simple_html_dom.php");


//require_once '../vendor/autoload.php';

//$url = "https://www.amazon.com/gp/registry/wishlist/20YXDMUE7M8AD?tag=wwwwebmastern";
//https://www.amazon.com/hz/wishlist/ls/20YXDMUE7M8AD?&sort=default


//View only
//https://www.amazon.com/hz/wishlist/ls/20YXDMUE7M8AD?ref_=wl_share
//http://www.amazon.com/hz/wishlist/ls/20YXDMUE7M8AD?ref_=wl_share
//www.amazon.com/hz/wishlist/ls/20YXDMUE7M8AD?ref_=wl_share
//View and edit
//https://www.amazon.com/hz/wishlist/dl/invite/enlX4Lz?ref_=wl_share

//test urls

//https://www.amazon.com/hz/wishlist/ls/2Q609TP9WRBQ9?&sort=default

//scrape amazon wishlist
$url = isset($_REQUEST['wishlistUrl']) && (strlen($_REQUEST['wishlistUrl']) < 200) ? $_REQUEST['wishlistUrl'] : null;
$headers = getallheaders(); //get headers from request to fool amazon's bot check
//(https:\/\/)?(www\.)?amazon\.co(.*)\/wishlist\/(.*)\/([[:alnum:]]+)(\/.*|\?.*)?

$re = '/(https:\/\/|http:\/\/)?(www\.)?amazon\.co(.*)\/wishlist\/(.*)\/([[:alnum:]]+)(\/.*|\?.*)?/m';
preg_match_all($re, $url, $matches, PREG_SET_ORDER, 0);
$wishlistId = $matches[0][5];

$country = isset($_REQUEST['country']) && (strlen($_REQUEST['country']) < 40) ? htmlspecialchars($_REQUEST['country']) : null;

//$url = "https://amazon.".$country."/hz/wishlist/ls/".$wishlistId."/?filter=DEFAULT&viewType=list&sort=default&type=wishlist&ajax=true"; //lek=a682f5a7-132b-4234-8464-fbc67b494b8f& (last evaulated key)

$endOfList = null;

$itemCount = 0;

$items = [];
error_log('readAmazonWishlist started');
if (isset($_POST['csrf_token']) && $_POST['csrf_token'] === $_SESSION['csrf_token']) {

    try {
        while (!$endOfList) {

            sleep(rand(1, 2)); // sleep a random amount to try and fool amazon's bot check
error_log('$url');

            $html = file_get_html($url, $headers);

            if (!is_array($html) && $html) {
error_log('got html');
                $gItems = $html->find('#g-items', 0);

                if ($gItems) {
error_log('got items');

                    $showMoreUrl = $gItems->find('#sort-by-price-load-more-items-url-next-batch', 0)->attr['value'];
///hz/wishlist/ls/20YXDMUE7M8AD?filter=DEFAULT&amp;viewType=list&amp;lek=8e65ee75-0da7-4618-87dd-9e055b720e9f&amp;sort=default&amp;type=wishlist
                    $url = "https://www.amazon." . $country . htmlspecialchars_decode($showMoreUrl);

                    if ($gItems->find('#endOfListMarker', 0)) { //last set of items to read
                        $endOfList = true;
                    }

                    $listItems = $gItems->find('li');

                    $viewItemCount = $html->find('#viewItemCount', 0);

                    if ($viewItemCount) {
                        $itemCount = $viewItemCount->attr['value'];
                        error_log('item count');
                        error_log($itemCount);
                    }
error_log('listItems count');
error_log(count($listItems));

                    foreach ($listItems as $key=>$item) {

                        $singleItem = [];
                        $singleItem['itemId'] = $item->attr['data-itemid'];
                        if ($item->attr['data-price'] == '-Infinity') {
                            $singleItem['price'] = "NO PRICE";
                        } else {
                            $price = $item->find('#itemPrice_' . $singleItem['itemId'] . " .a-offscreen", 0);
                            if ($price) {
                                $singleItem['price'] = $price->plaintext;
                            } else {
                                $singleItem['price'] = "NO PRICE";
                            }
                        }
                        $id = '#itemName_' . $singleItem['itemId'];
                        if (isset($item->find($id, 0)->attr['title'])) {
                            $singleItem['name'] = htmlspecialchars($item->find($id, 0)->attr['title'], ENT_QUOTES, "UTF-8", false);
                        } else {
                            $singleItem['name'] = 'NO NAME';
                        }
                        $singleItem['img'] = $item->find('img', 0)->attr['src'];
                        $singleItem['link'] = "https://www.amazon." . $country . $item->find('a', 0)->attr['href']; //add affiliate ID
                        $items[] = $singleItem;
                    }
                }
            } else {
                error_log('readAmazonWishlist: html not returned for ' . $url);
            }
        }
        $html = null;
        $json = json_encode($items);

        echo $json;
    } catch (Exception $e) {
        error_log($e->getMessage());
        $response = ["error" => $e->getMessage()];
        echo json_encode($response);
    }


//print_r($items);
//TODO add back caching of file
//$cache_file = __DIR__ . DIRECTORY_SEPARATOR . 'wishlist.json.cache.temp';
//$success = file_put_contents($cache_file, $json, FILE_TEXT);

} else {
    $response = ["error" => "CSRF Error"];
    echo json_encode($response);
}