class EasyAmazonWishlistPagination {

    // class methods
    constructor(paginationLimit, wishlistSize) {
 //       this.wishlist = wishlist;
        this.totalItems = wishlistSize;
        this.paginationLimit = paginationLimit;
        this.currentPage = 1;
        this.startItemNum = 1;
        this.totalPages = Math.ceil(this.totalItems / this.paginationLimit);
        if (!paginationLimit || (this.totalItems <= this.paginationLimit)) {
            this.endItemNum = this.totalItems;
        } else {
            this.endItemNum = this.paginationLimit;
        }
        //jQuery('#easy-amazon-wishlist-list .pagination-row .page-count').text('(Page ' + this.currentPage + ' of ' + this.totalPages + ')')

    }

    createButtonEvents(){

        var easyAmazonWishlistNavigation = this;
        //button events...have to be added AFTER elements added to DOM
        jQuery(document).on("click", "#easy-amazon-wishlist-list .pagination-first", function (e) {
            e.preventDefault();
            e.stopPropagation();
            easyAmazonWishlistNavigation.firstPage();
        });
        jQuery(document).on("click", "#easy-amazon-wishlist-list .pagination-previous", function (e) {
            e.preventDefault();
            e.stopPropagation();
            easyAmazonWishlistNavigation.previousPage();
        });
        jQuery(document).on("click", "#easy-amazon-wishlist-list .pagination-next", function (e) {
            e.preventDefault();
            e.stopPropagation();
            easyAmazonWishlistNavigation.nextPage();
        });
        jQuery(document).on("click", "#easy-amazon-wishlist-list .pagination-last", function (e) {
            e.preventDefault();
            e.stopPropagation();
            easyAmazonWishlistNavigation.lastPage();
        });
    }

    updatePagination(paginationLimit) { //Resets pagination based on new pagination Limit

        this.currentPage = 1;
        this.paginationLimit = paginationLimit;
        this.totalPages = Math.ceil(this.totalItems / this.paginationLimit);
        this.startItemNum = 1; //((this.totalItems - 1) * this.paginationLimit)
        if (this.paginationLimit <= this.totalItems) {
            this.endItemNum = this.paginationLimit;
        } else {
            this.endItemNum = this.totalItems;
        }

        this.showPage(1, 'left');

        jQuery('#easy-amazon-wishlist-list .pagination-row').html(this.toString());
    }

    firstPage() {
        if (this.currentPage !== 1) {
            this.currentPage = 1;
            this.showPage(this.currentPage, 'left');
        }


    }

    lastPage() {
        if (this.currentPage !== this.totalPages) {
            this.currentPage = this.totalPages;
            this.showPage(this.currentPage, 'right');
        }

    }

    previousPage() {
        if ((this.currentPage - 1) >= 1) {
            this.currentPage = this.currentPage - 1;
            this.showPage(this.currentPage, 'left');
        }
    }

    nextPage() {
        if ((this.currentPage + 1) <= this.totalPages) {
            this.currentPage = this.currentPage + 1;
            this.showPage(this.currentPage, 'right');
        }
    }

    //traverse through items and turn off/ turn on relevant items
    showPage(page, slideDirection) {

        // First Page
        //TODO remove checks because the else case will never be called
        //Update classes for direction navigation arrows
        if (page == 1) {
            if (this.paginationLimit <= this.totalItems) {
                this.startItemNum = 1;
                this.endItemNum = this.paginationLimit;
            } else {
                this.startItemNum = 1;
                this.endItemNum = this.totalItems;
            }
        }

        // Last Page TODO almost got it right...showing one too many on last page now
        if (page == this.totalPages) {
            if (this.totalItems > this.paginationLimit) {
                var remainder = this.totalItems % this.paginationLimit;
                if (remainder == 0) {
                    this.startItemNum = this.totalItems - this.paginationLimit;
                    this.endItemNum = this.totalItems;
                } else {
                    this.startItemNum = this.totalItems - remainder;
                    this.endItemNum = this.totalItems;
                }
            }
        }

        // Some page in the middle
        if (page > 1 && page < this.totalPages) {
            this.startItemNum = ((page - 1) * this.paginationLimit) + 1;
            this.endItemNum = this.startItemNum + (this.paginationLimit - 1);
        }

        var start = this.startItemNum - 1;
        var end = this.endItemNum - 1;
        // Hide all the wishlist items first
        var wishlistItemsDom = jQuery('#easy-amazon-wishlist-list .single-list-item');

        wishlistItemsDom.hide(function () {
            jQuery.each(wishlistItemsDom, function (key, wishlistItem) { //key starts at 0
                if (key >= start && key <= end) {
                    jQuery(wishlistItem).show();
                }
            });
        });
        /*jQuery(wishlistItem).animate({
              width: jQuery(wishlistItem).width()
          });*/

        jQuery('#easy-amazon-wishlist-list .pagination-row .page-count').text('(Page ' + page + ' of ' + this.totalPages + ')')
    }

    toString() {
        var navigation = '';
        //TODO add all these variables into constructor
        if(this.paginationLimit){
            if (this.currentPage > 1) {
                // backtrack
                this.prevpage = this.currentPage - 1;
                this.firstBack = '<nav aria-label="Pagination"><ul class="pagination"><li class="pagination-first">&lt;&lt;</li> <li class="pagination-previous">&nbsp;&nbsp;&lt;</li>';
            } else {
                this.firstBack = '<nav aria-label="Pagination"><ul class="pagination"><li class="pagination-first disabled">&lt;&lt;</li> <li class="pagination-previous disabled">&nbsp;&nbsp;&lt;</li>';
            }
            this.where = "<li class='page-count' title='" + this.totalItems + " items total'>(Page " + this.currentPage + " of " + this.totalPages + ")</li>";
            if (this.currentPage < this.totalPages) {
                // forward
                this.nextpage = this.currentPage + 1;

                // 'next' and 'last' links
                this.nextLast = " <li class='pagination-last'>&gt;&gt;</li> <li class='pagination-next'>&gt;&nbsp;&nbsp;</li></ul></nav>";
            } else {
                this.nextLast = " <li class='pagination-last disabled'>&gt;&gt;</li> <li class='pagination-next disabled'>&gt;&nbsp;&nbsp;</li></ul></nav>";
            }
            navigation = this.firstBack + this.where + this.nextLast;
        }

        return navigation;
    }

}
